<template>
  <div class="flex align-items-center justify-content-center pt-8">
    <div class="surface-card p-4 shadow-2 border-round w-full lg:w-6 ml-4 mr-4">
      <div class="text-900 text-3xl font-medium mb-3">Forgot Password</div>

      <form @submit.prevent="sendForgotPassword">
        <Message @close="clearErrors" v-if="error.isShown" severity="error">
          {{ error.message }}
        </Message>
        <Message @close="isEmailSent = false" v-if="isEmailSent">
          Email sent, check your inbox
        </Message>
        <label for="email" class="block text-900 font-medium mb-2">
          Email
        </label>
        <InputText v-model="email" id="email" type="text" class="w-full mb-3" />
        <Button type="submit" label="Send" class="w-full"></Button>
      </form>

      <div class="pt-3 flex justify-content-center align-align-items-center">
        Remembered your password? Click
        <router-link
          :to="{ name: 'Login' }"
          class="font-medium text-blue-500 ml-1 cursor-pointer no-underline"
          >here</router-link
        >
      </div>
    </div>
  </div>
</template>

<script>
import authService from "@/services/auth/auth-service";

export default {
  name: "ForgotPassword",
  data() {
    return {
      email: "",
      error: {
        message: "",
        isShown: false,
      },
      isEmailSent: false,
    };
  },
  methods: {
    async sendForgotPassword() {
      if (this.email.trim() === "") {
        this.error = {
          message: "Please provide an email",
          isShown: true,
        };

        return;
      }

      try {
        await authService.sendForgotPassword(this.email);
      } catch (e) {
        console.log("Email not found");
      }

      this.isEmailSent = true;
      this.clearForm();
      this.clearErrors();
    },
    clearErrors() {
      this.error = {
        message: "",
        isShown: false,
      };
    },
    clearForm() {
      this.email = "";
    },
  },
};
</script>

<style scoped>
</style>